'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _objectValues = require('object-values');

var _objectValues2 = _interopRequireDefault(_objectValues);

var _Transition = require('react-transition-group/Transition');

var _Transition2 = _interopRequireDefault(_Transition);

var _evergreenLayers = require('evergreen-layers');

var _evergreenPortal = require('evergreen-portal');

var _popoverSides = require('../popover-sides');

var _popoverSides2 = _interopRequireDefault(_popoverSides);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var INITIAL_SCALE = 0.9;

var animationEasing = {
  standard: 'cubic-bezier(0.4, 0.0, 0.2, 1)',
  deceleration: 'cubic-bezier(0.0, 0.0, 0.2, 1)',
  acceleration: 'cubic-bezier(0.4, 0.0, 1, 1)',
  sharp: 'cubic-bezier(0.4, 0.0, 0.6, 1)',
  spring: 'cubic-bezier(0.175, 0.885, 0.320, 1.175)'
};

var styles = function styles(_ref) {
  var targetOffset = _ref.targetOffset,
      animationDuration = _ref.animationDuration;
  return {
    position: 'absolute',
    opacity: 0,
    transition: 'all ' + animationDuration + 'ms ' + animationEasing.spring,
    transform: 'scale(' + INITIAL_SCALE + ') translateY(-4px)',
    '&[data-state="entering"][data-position="bottom"], &[data-state="entered"][data-position="bottom"]': {
      opacity: 1,
      visibility: 'visible',
      transform: 'scale(1) translateY(' + targetOffset + 'px)'
    },
    '&[data-state="entering"][data-position="top"], &[data-state="entered"][data-position="top"]': {
      opacity: 1,
      visibility: 'visible',
      transform: 'scale(1) translateY(-' + targetOffset + 'px)'
    },
    '&[data-state="exiting"]': {
      opacity: 0,
      transform: 'scale(1) translateY(0)'
    }
  };
};

var initialState = function initialState() {
  return {
    top: null,
    left: null,
    side: null,
    transformOriginX: null
  };
};

var PopoverContentCard = function (_Component) {
  _inherits(PopoverContentCard, _Component);

  function PopoverContentCard() {
    _classCallCheck(this, PopoverContentCard);

    var _this = _possibleConstructorReturn(this, (PopoverContentCard.__proto__ || Object.getPrototypeOf(PopoverContentCard)).call(this));

    _this.getAnchors = function () {
      var targetRect = _this.props.targetRect;

      var bodyRect = document.body.getBoundingClientRect();
      var x = targetRect.left + targetRect.width / 2;
      return {
        top: {
          x: x,
          y: targetRect.top - bodyRect.top
        },
        bottom: {
          x: x,
          y: targetRect.bottom - bodyRect.top
        }
      };
    };

    _this.handleEnter = function () {
      var _this$props = _this.props,
          useSmartPositioning = _this$props.useSmartPositioning,
          bodyOffset = _this$props.bodyOffset;

      var _this$getAnchors = _this.getAnchors(),
          top = _this$getAnchors.top,
          bottom = _this$getAnchors.bottom;

      var side = _this.props.side;

      // Smartly position the popover when it overflows the body
      var popoverRect = _this.popoverNode.getBoundingClientRect();
      popoverRect.width *= 1 / INITIAL_SCALE;
      popoverRect.height *= 1 / INITIAL_SCALE;
      var viewportHeight = document.documentElement.clientHeight + window.scrollY;
      var viewportWidth = document.documentElement.clientWidth + window.scrollX;

      if (useSmartPositioning && popoverRect.height + bottom.y > viewportHeight) {
        side = 'top';
      }

      _this.popoverNode.setAttribute('data-position', side);

      var left = Math.max(bottom.x - popoverRect.width / 2, bodyOffset);
      left = Math.min(left, viewportWidth - popoverRect.width - bodyOffset);

      var transformOriginX = bottom.x - left;
      transformOriginX = Math.max(transformOriginX - bodyOffset, bottom.x - left);

      _this.setState({
        left: left,
        side: side,
        transformOriginX: transformOriginX,
        top: side === _popoverSides2.default.BOTTOM ? bottom.y : top.y - popoverRect.height
      });
    };

    _this.handleExited = function () {
      _this.setState(initialState());
    };

    _this.state = initialState();
    return _this;
  }

  _createClass(PopoverContentCard, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          isOpen = _props.isOpen,
          zIndex = _props.zIndex,
          _innerRef = _props.innerRef,
          targetOffset = _props.targetOffset,
          animationDuration = _props.animationDuration;
      var _state = this.state,
          left = _state.left,
          top = _state.top,
          side = _state.side,
          transformOriginX = _state.transformOriginX;


      var transformOrigin = transformOriginX + 'px ' + (side === _popoverSides2.default.BOTTOM ? 'top' : 'bottom');

      return _react2.default.createElement(
        _evergreenPortal.Portal,
        null,
        _react2.default.createElement(
          _Transition2.default,
          {
            'in': isOpen,
            timeout: animationDuration,
            onEnter: this.handleEnter,
            onExited: this.handleExited,
            unmountOnExit: true
          },
          function (state) {
            return _react2.default.createElement(
              _evergreenLayers.Card,
              {
                role: 'dialog',
                elevation: 3,
                backgroundColor: 'white',
                overflow: 'hidden',
                'data-state': state,
                css: _extends({}, styles({ targetOffset: targetOffset, animationDuration: animationDuration })),
                style: {
                  left: left,
                  top: top,
                  transformOrigin: transformOrigin,
                  zIndex: zIndex
                },
                innerRef: function innerRef(node) {
                  _this2.popoverNode = node;
                  _innerRef(node);
                },
                minWidth: 200
              },
              children
            );
          }
        )
      );
    }
  }]);

  return PopoverContentCard;
}(_react.Component);

PopoverContentCard.propTypes = _extends({}, _evergreenLayers.Card.propTypes, {
  side: _propTypes2.default.oneOf((0, _objectValues2.default)(_popoverSides2.default)),
  isOpen: _propTypes2.default.bool.isRequired,
  zIndex: _propTypes2.default.number,
  children: _propTypes2.default.node,
  innerRef: _propTypes2.default.func,
  bodyOffset: _propTypes2.default.number,
  targetOffset: _propTypes2.default.number,
  animationDuration: _propTypes2.default.number,
  useSmartPositioning: _propTypes2.default.bool
});
PopoverContentCard.defaultProps = {
  animationDuration: 300
};
exports.default = PopoverContentCard;